# GNU Enterprise Application Server - Class Repository
#
# Copyright 2003 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with program; see the file COPYING. If not, 
# write to the Free Software Foundation, Inc., 59 Temple Place 
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: __init__.py,v 1.14 2003/10/21 12:26:50 jvetter Exp $

import os, sys

from Module import *
from Class  import *
from Namespace import *
from Definition import *
from gnue import paths
from gnue.appserver.language import Session

# -----------------------------------------------------------------------------
# Global module and class list
# -----------------------------------------------------------------------------

modules = None
classes = None

def init (server):
  global modules, classes
  
  # First, load the hardwired default repository
  try:
    basedir  = os.path.dirname(sys.modules["gnue.appserver.classrep"].__file__)
  except:
    basedir  = os.path.dirname(__file__)    
  if not os.path.isfile (os.path.join (basedir, "repository.ini")):
    basedir = os.path.join (paths.data, "share", "gnue", "appserver")

  defaultRepository = os.path.join (basedir, "repository.ini")
  modules = ModuleDict (None, RepositoryDefinition (defaultRepository))
  classes = ClassDict (None, modules)

  # Now, we can access the database to load the real repository
  session = Session.InternalSession (server)
  new_modules = ModuleDict (session)
  new_classes = ClassDict (session, new_modules)
  modules = new_modules
  classes = new_classes
  modules.classdict = classes
  return
