#
# Populate the database with class repository definition
#

from language import App
from Namespace import *
from gnue.appserver import classrep

# First we have to create a session from the language interface
app = App.App ()
lSession = app.newSession ("hacker", "secret")

# Now load the initial class repository
print "Loading repository definition ..."
crdef = classrep.RepositoryDefinition ('classrep/repository.ini')


print "Retrieving existing modules ..."
modules = lSession.find ('gnue_module')

for moduleDef in crdef.modules ():

  if moduleDef [0] in [cmod.gnue_name for cmod in modules]:
    newModule = None

    for cmod in modules:
      if cmod.gnue_name == moduleDef [0]:
	newModule = cmod
	break
    print "Using:", newModule.gnue_name, newModule.gnue_id

  else:
    print "Building new module:", moduleDef [0]

    newModule = lSession.new ('gnue_module')
    newModule.gnue_name    = moduleDef [1].gnue_name
    newModule.gnue_comment = moduleDef [1].gnue_comment
    newModule.store ()
    print "Stored %s as %s" % (newModule.gnue_name, newModule.objectId)

  print "Retrieving classes of '%s' ..." % moduleDef [0]
  classes = lSession.find ('gnue_class', 
         [["eq", ""], ["field", "gnue_module"], ["const", newModule.objectId]])
  kllist = [createName (newModule.gnue_name, kl.gnue_name) for kl in classes]

  # Adding all classes of 'newModule'
  for clDef in crdef.classes (newModule.gnue_name):
    # since we need the classes property-dictionary later, we require the
    # class-dictionary here (using the apropriate module-id).
    aClass = classrep.classes [clDef [0]]
    aClass.gnue_module = newModule.objectId

    if clDef [0] in kllist:
      newClass = None
      for klass in classes:
	if createName (newModule.gnue_name, klass.gnue_name) == clDef [0]:
	  newClass = klass
	  break

      print "Using class:", newClass.gnue_name, newClass.objectId

    else:
      print "Building new class:", clDef [0]
      newClass = lSession.new ('gnue_class')
      newClass.gnue_module  = aClass.gnue_module
      newClass.gnue_name    = aClass.gnue_name
      newClass.gnue_comment = aClass.gnue_comment
      newClass.store ()
      print "Stored %s as %s" % (newClass.gnue_name, newClass.objectId)

    print "Retrieving properties of '%s' ..." % clDef [0]
    plist = lSession.find ('gnue_property', 
        [["eq", ""], ["field", "gnue_class"], ["const", newClass.objectId],
	 ["eq", ""], ["field", "gnue_module"], ["const", aClass.gnue_module]])
    properties = [pr.gnue_name for pr in plist]

    for prop in aClass.properties.values ():
      if prop.fullName in properties:
	continue

      print "Adding property:", prop.fullName

      newProp = lSession.new ('gnue_property')
      newProp.gnue_class     = newClass.objectId
      newProp.gnue_module    = aClass.gnue_module
      newProp.gnue_name      = prop.gnue_name
      newProp.gnue_comment   = prop.gnue_comment
      newProp.gnue_length    = prop.gnue_length
      newProp.gnue_type      = prop.gnue_type
      newProp.gnue_precision = prop.gnue_precision
      newProp.store ()


  print "Committing module '%s' ..." % newModule.gnue_name
  lSession.commit ()

