# GNU Enterprise Application Server - Testing unit for Class Repository
#
# Copyright 2003 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with program; see the file COPYING. If not, 
# write to the Free Software Foundation, Inc., 59 Temple Place 
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: mtest.py,v 1.4 2003/09/18 15:14:10 jvetter Exp $
#
# This testing unit dumps some values of class definitions.
#

from language import App
from gnue.appserver import classrep

# First we have to create a session from the language interface
app = App.App ()

# -----------------------------------------------------------------------------
# Dump some values of a class definition
# -----------------------------------------------------------------------------
def dumpClass (aName):
  print "\nRequesting class '%s' ..." % aName
  aClass = classrep.classes [aName]

  print "Fullname:", aClass.fullName
  print "Id      :", aClass.gnue_id
  print "Module  :", aClass.module.fullName
  print "Comment :", aClass.gnue_comment

  print "\nProperties:"

  for prop in aClass.properties.values ():
    print "Fullname:", prop.fullName
    print "Comment :", prop.gnue_comment
    print "Module  :", prop.klass.module.fullName
    print "Type    :", prop.gnue_type
    print 

  print "End of dump for '%s'\n" % aName

# dump some class definitions
dumpClass ('address_person')
dumpClass ('gnue_class')

print "Searching for property 'gnue_name' in class 'gnue_property' ..."
x = classrep.classes ['gnue_property']
y = x.findProp ('gnue_name')
print "Fullname:", y.fullName
print "Module  :", y.klass.module.fullName
print "Type    :", y.gnue_type
