# GNU Enterprise Application Server - Testing unit 
#
# Copyright 2003 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with program; see the file COPYING. If not, 
# write to the Free Software Foundation, Inc., 59 Temple Place 
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: test.py,v 1.8 2003/10/21 12:26:50 jvetter Exp $
#

from gnue.appserver.language import App
from gnue.appserver import classrep

from gnue.appserver.test import testApp

app = testApp ()
sm  = app.getSessionManager ()

print "Already loaded modules:", sm.modules.keys ()
print "Already loaded classes:", sm.classes.keys ()

print '\nModule "address":'
m = sm.modules ["address"]
print "%s: %s\n" % (m.gnue_name, m.gnue_comment)

print "Classes in 'address':"
for k in m.classes.keys ():
  print k

print "Number of modules: %d\n" % len (sm.modules)

print "All modules via keys ():"
for k in sm.modules.keys ():
  m = sm.modules [k]
  print k, ":", m.gnue_comment

print
print "All modules via values ():"
for m in sm.modules.values ():
  print m.gnue_name + ": " + m.gnue_comment

print
print "All modules via items ():"
for i in sm.modules.items ():
  print i

print
print 'Is there a module "address": %d' % sm.modules.has_key ("address")
print 'Is there a module "foo": %d' % sm.modules.has_key ("foo")
