# GNU Enterprise Application Server - List Object
#
# Copyright 2001-2003 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with program; see the file COPYING. If not, 
# write to the Free Software Foundation, Inc., 59 Temple Place 
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: geasBClass.py,v 1.5 2003/02/17 07:31:06 jcater Exp $

from gnue.common.datasources import GDataSource,GConditions
import geasInstance
import string

# =============================================================================
# List class
# =============================================================================

class geasBClass:

  # ---------------------------------------------------------------------------
  # Initalize
  # ---------------------------------------------------------------------------

  def __init__ (self, session, classname):
    self._session = session
    self._classname = classname


  def _populate (self):
  
    if hasattr(self,"_sort"):
      sorting = string.joinfields(self._sort,",")
    else: 
      sorting = None
    
    self._datasource = GDataSource.DataSourceWrapper(
                            connections=self._session._connections, 
                            fields=self._prefetch, 
                            init=1, 
                            attributes = {
                               "name": "tmp", 
                               "connection": self._session._database,
                               "table": self._classname, 
                               "order_by": sorting } )

    if hasattr(self,"_conditionTree"):
      self._resultset = self._datasource.createResultSet(self._conditionTree)
    else:
      self._resultset = self._datasource.createResultSet()
      


  def _firstInstance (self):
    if self._classname!='appserver_pytrigger':
      trigger=self._session._triggerMg.getTriggerByEvent \
               ('%s:pre_first_inst' % self._classname)
      if trigger!=None:
        trigger()
        
    if self._resultset.firstRecord () != 0:
      return geasInstance.geasInstance (self,  self._resultset.current)
    else:
      return None

  # ---------------------------------------------------------------------------
  # Get the next instance in the list
  # ---------------------------------------------------------------------------

  def _nextInstance (self):
    if self._resultset.nextRecord () != 0:
      return geasInstance.geasInstance (self, self._resultset.current)
    else:
      return None

  # ---------------------------------------------------------------------------
  # insert a new empty instance in the list and return it 
  # ---------------------------------------------------------------------------

  def _insertNewInstance (self):
    self._resultset.insertRecord ()
    return geasInstance.geasInstance (self, self._resultset.current)

  def load(self,obj_id_list,propertylist):
    # method 1: build one resultset out of the whole stuff
    # method 2: load every record one by one 

    # doing method 1:
    
    # 1. build condition:
    for i in obj_id_list:
      
      pass

    # 2. set prefetch
    propertylist.add('gnue_id')
    self._prefetch=propertylist

    # 3. load recordset
    self._populate()

    
  
  def store(self,obj_id_list,propertylist,data):
    for i in obj_id_list:
      ## check for oid here
      if 0:
        # store record here
        pass
      else:        
        print "'%s' is no valid obj id" % i
  
  def call(self,obj_id_list,methodname,parameters):
    pass
    
  def delete(self,obj_id_list):
    for i in obj_id_list:
      ## check for oid here
      if 0:
        # store record here
        pass
      else:        
        print "'%s' is no valid obj id" % i
