# GNU Enterprise Application Server - List Object
#
# Copyright 2001 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: geasConfiguration.py,v 1.4 2003/09/01 18:01:45 reinhard Exp $

from gnue.common.formatting import GTypecast


ConfigOptions = (

  { 'Name'       : 'database',
    'Type'       : 'Setting',
    'Comment'    : 'Name of the database connection appserver is using',
    'Description': 'Name of the database connection appserver is using',
    'Typecast'   : GTypecast.text,
    'Default'    : 'gnue' },

  { 'Name'       : 'rpctype',
    'Type'       : 'Setting',
    'Comment'    : 'RPC Interface Type appserver is providing',
    'Description': 'RPC Interface Type appserver is providing',
    'Typecast'   : GTypecast.text,
    'Default'    : 'xmlrpc' },

  { 'Name'       : 'rpcport',
    'Type'       : 'Setting',
    'Comment'    : 'Port (if needed) for RPC Interface',
    'Description': 'Port (if needed) for RPC Interface',
    'Typecast'   : GTypecast.whole,
    'Default'    : '8765' },

  { 'Name'       : 'allowed_hosts',
    'Type'       : 'Setting',
    'Comment'    : 'Hosts which are allowed to access appserver.',
    'Description': 'Hosts which are allowed to access appserver.',
    'Typecast'   : GTypecast.text,
    'Default'    : '' },

  { 'Name'       : 'httpdir',
    'Type'       : 'Setting',
    'Comment'    : 'Directory, where files which appserver should serve per'+\
                   ' http are stored',
    'Description': 'Directory, where files which appserver should serve per'+\
                   ' http are stored',
    'Typecast'   : GTypecast.text,
    'Default'    : "/this_dir_shouldn't exist." }, # default should be overridden
)
