# GNU Enterprise Application Server - Test Program
#
# Copyright 2001-2003 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: test.py,v 1.19 2003/10/09 21:42:10 siesel Exp $

import os
from gnue.common.apps import GClientApp
from gnue.common.datasources import GLoginHandler
import geasSessionManager

# =============================================================================
# Test application
# =============================================================================

class testApp (GClientApp.GClientApp):

  def __init__(self, connections=None):
    ConfigOptions = {}
    GClientApp.GClientApp.__init__(self, connections,'none',ConfigOptions)


  # ---------------------------------------------------------------------------
  # Create a session manager object
  # ---------------------------------------------------------------------------

  def getSessionManager (self):
    # set up login handler
    self.connections.setLoginHandler (testLoginHandler ())

    print "Creating session manager ..."
    sm = geasSessionManager.geasSessionManager (self.connections)

    return sm

  # ---------------------------------------------------------------------------
  # Main program
  # ---------------------------------------------------------------------------

  def run (self):
    sm = self.getSessionManager ()

    print "Opening session ..."
    session = sm.open ({"user":"hacker", "password":"secret"})

    print "Creating and populating list object ..."
    list = sm.request (session, "address_person", [], ["address_zip"],
                       ["address_name", "address_street", "address_city"])

    print "Retrieving first instance ..."
    rset = sm.fetch (session,list,0,1)

    print "These are the values of the first instance:"
    print "  Name  :", rset[0][1]
    print "  Street:", rset[0][2]
    print "  City  :", rset[0][3]

    print "Now I call the procedure 'show' for the first instance:"
    sm.call (session, "address_person", [rset[0][0]], "show", "")

# =============================================================================
# Login Handler
# =============================================================================

class testLoginHandler (GLoginHandler.LoginHandler):
  def getLogin (self, *arguments):
    return {"_username": "gnue", "_password": None}

# =============================================================================
# Let it rock
# =============================================================================

if __name__ == "__main__":
  testApp().run()
  print "Thank you for playing!"
